# Ads Data Hub API

API for executing Ads Data Hub queries.

- [REST Resource: v1.customers](https://developers.google.com/ads-data-hub/reference/rest#v1.customers)
- [REST Resource: v1.customers.adsDataCustomers](https://developers.google.com/ads-data-hub/reference/rest#v1.customers.adsDataCustomers)
- [REST Resource: v1.customers.adsDataLinks](https://developers.google.com/ads-data-hub/reference/rest#v1.customers.adsDataLinks)
- [REST Resource: v1.customers.analysisQueries](https://developers.google.com/ads-data-hub/reference/rest#v1.customers.analysisQueries)
- [REST Resource: v1.customers.crmBasedUserListQueries](https://developers.google.com/ads-data-hub/reference/rest#v1.customers.crmBasedUserListQueries)
- [REST Resource: v1.customers.customBiddingAlgorithms](https://developers.google.com/ads-data-hub/reference/rest#v1.customers.customBiddingAlgorithms)
- [REST Resource: v1.customers.inboundCustomerLinks](https://developers.google.com/ads-data-hub/reference/rest#v1.customers.inboundCustomerLinks)
- [REST Resource: v1.customers.outboundCustomerLinks](https://developers.google.com/ads-data-hub/reference/rest#v1.customers.outboundCustomerLinks)
- [REST Resource: v1.customers.tables](https://developers.google.com/ads-data-hub/reference/rest#v1.customers.tables)
- [REST Resource: v1.customers.tempTables](https://developers.google.com/ads-data-hub/reference/rest#v1.customers.tempTables)
- [REST Resource: v1.customers.userListQueries](https://developers.google.com/ads-data-hub/reference/rest#v1.customers.userListQueries)
- [REST Resource: v1.customers.userLists](https://developers.google.com/ads-data-hub/reference/rest#v1.customers.userLists)
- [REST Resource: v1.operations](https://developers.google.com/ads-data-hub/reference/rest#v1.operations)
- [REST Resource: v1.outages](https://developers.google.com/ads-data-hub/reference/rest#v1.outages)

## Service: adsdatahub.googleapis.com

To call this service, we recommend that you use the Google-provided [client libraries](https://cloud.google.com/apis/docs/client-libraries-explained). If your application needs to use your own libraries to call this service, use the following information when you make the API requests.

### Discovery document

A [Discovery Document](https://developers.google.com/discovery/v1/reference/apis) is a machine-readable specification for describing and consuming REST APIs. It is used to build client libraries, IDE plugins, and other tools that interact with Google APIs. One service may provide multiple discovery documents. This service provides the following discovery document:

- <https://adsdatahub.googleapis.com/$discovery/rest?version=v1>

### Service endpoint

A [service endpoint](https://cloud.google.com/apis/design/glossary#api_service_endpoint) is a base URL that specifies the network address of an API service. One service might have multiple service endpoints. This service has the following service endpoint and all URIs below are relative to this service endpoint:

- `https://adsdatahub.googleapis.com`

## REST Resource: [v1.customers](https://developers.google.com/ads-data-hub/reference/rest/v1/customers)

| Methods ||
|---|---|
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers/describeValidDv360AdvertiserIds` | `POST /v1/{customer=customers/*}:describeValidDv360AdvertiserIds` Describes the valid DV360 AdvertiserIds |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers/describeValidFrequencyLimitingEventMatchers (deprecated)` | `GET /v1/{customer=customers/*}:describeValidFrequencyLimitingEventMatchers` Lists valid event matchers along with their metadata for frequency capping audience lists. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers/exportJobHistory` | `POST /v1/{customer=customers/*}:exportJobHistory` Exports job history of a customer account to customer-selected BigQuery dataset. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers/generateDv360IvtVideoViewabilityReport` | `POST /v1/{customer=customers/*}:generateDv360IvtVideoViewabilityReport` Starts the execution of a query to retrieve invalid traffic viewability metrics for the DV360 platform. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers/generateIvtReport` | `POST /v1/{name=customers/*}:generateIvtReport` Starts the execution of a query to retrieve a day-by-day summary of invalid traffic counts for a specific platform. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers/get` | `GET /v1/{name=customers/*}` Retrieves the requested Ads Data Hub customer. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers/getImportCompletionStatus` | `GET /v1/{customer=customers/*}/importCompletionStatus` Returns the percentage of Google data across all customers that has successfully been ingested into ADH on the given date. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers/list` | `GET /v1/customers` Lists Ads Data Hub customers to which the current user has access. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers/submitBrandLiftBenchmark` | `POST /v1/{customer=customers/*}:submitBrandLiftBenchmark` Starts ADH import of a specified BigQuery table populated with the quarterly brand lift benchmark report generated by the customer. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers/submitBrandLiftStudyReport` | `POST /v1/{customer=customers/*}:submitBrandLiftStudyReport` Starts ADH import of a specified BigQuery table populated with the brand lift study report generated by the customer. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers/submitBrandSafetyScores` | `POST /v1/{customer=customers/*}:submitBrandSafetyScores` Starts ADH import of a specified BigQuery table populated with the vendor's Brand Safety score file. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers/submitVendorAggregatesReport` | `POST /v1/{customer=customers/*}:submitVendorAggregatesReport` Starts ADH import of a specified BigQuery table populated with the vendor's summary report for a given metric. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers/submitVendorReportIdMapping` | `POST /v1/{customer=customers/*}:submitVendorReportIdMapping` Starts ADH import of a specified BigQuery table populated with the mapping between customer defined report ID and Google campaign ID. |

## REST Resource: [v1.customers.adsDataCustomers](https://developers.google.com/ads-data-hub/reference/rest/v1/customers.adsDataCustomers)

| Methods ||
|---|---|
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.adsDataCustomers/get` | `GET /v1/{name=customers/*/adsDataCustomers/*}` Retrieves the requested Ads Data Hub customer. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.adsDataCustomers/getDataAccessBudget` | `GET /v1/{name=customers/*/adsDataCustomers/*/dataAccessBudget}` Retrieves the data access budget for the requested ads data source for the last 366 days. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.adsDataCustomers/list` | `GET /v1/{parent=customers/*}/adsDataCustomers` Lists ads data customers accessible from the customer. |

## REST Resource: [v1.customers.adsDataLinks](https://developers.google.com/ads-data-hub/reference/rest/v1/customers.adsDataLinks)

| Methods ||
|---|---|
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.adsDataLinks/batchApprove` | `POST /v1/{parent=customers/*}/adsDataLinks:batchApprove` Approve a list of pending ads data links. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.adsDataLinks/batchReject` | `POST /v1/{parent=customers/*}/adsDataLinks:batchReject` Reject a list of pending ads data links. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.adsDataLinks/list` | `GET /v1/{parent=customers/*}/adsDataLinks` Lists links between the specified customer and other Google advertising entities. |

## REST Resource: [v1.customers.analysisQueries](https://developers.google.com/ads-data-hub/reference/rest/v1/customers.analysisQueries)

| Methods ||
|---|---|
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.analysisQueries/create` | `POST /v1/{parent=customers/*}/analysisQueries` Creates an analysis query for later execution. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.analysisQueries/delete` | `DELETE /v1/{name=customers/*/analysisQueries/*}` Deletes an analysis query. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.analysisQueries/get` | `GET /v1/{name=customers/*/analysisQueries/*}` Retrieves the requested analysis query. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.analysisQueries/list` | `GET /v1/{parent=customers/*}/analysisQueries` Lists the analysis queries owned by the specified customer. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.analysisQueries/patch` | `PATCH /v1/{query.name=customers/*/analysisQueries/*}` Updates an existing analysis query. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.analysisQueries/start` | `POST /v1/{name=customers/*/analysisQueries/*}:start` Starts execution on a stored analysis query. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.analysisQueries/startTransient` | `POST /v1/{parent=customers/*}/analysisQueries:startTransient` Starts execution on a transient analysis query. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.analysisQueries/validate` | `POST /v1/{parent=customers/*}/analysisQueries:validate` Performs static validation checks on the provided analysis query. |

## REST Resource: [v1.customers.crmBasedUserListQueries](https://developers.google.com/ads-data-hub/reference/rest/v1/customers.crmBasedUserListQueries)

| Methods ||
|---|---|
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.crmBasedUserListQueries/create` | `POST /v1/{parent=customers/*}/crmBasedUserListQueries` Creates a CRM based user list query for later execution. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.crmBasedUserListQueries/delete` | `DELETE /v1/{name=customers/*/crmBasedUserListQueries/*}` Deletes a CRM based user list query. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.crmBasedUserListQueries/get` | `GET /v1/{name=customers/*/crmBasedUserListQueries/*}` Retrieves the requested CRM based user list query. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.crmBasedUserListQueries/list` | `GET /v1/{parent=customers/*}/crmBasedUserListQueries` Lists the CRM based user list queries owned by the specified customer. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.crmBasedUserListQueries/patch` | `PATCH /v1/{query.name=customers/*/crmBasedUserListQueries/*}` Updates an existing CRM based user list query. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.crmBasedUserListQueries/validate` | `POST /v1/{parent=customers/*}/crmBasedUserListQueries:validate` Performs static validation checks on the provided CRM based user list query to ensure valid output schema. |

## REST Resource: [v1.customers.customBiddingAlgorithms](https://developers.google.com/ads-data-hub/reference/rest/v1/customers.customBiddingAlgorithms)

| Methods ||
|---|---|
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.customBiddingAlgorithms/addAdvertiser` | `POST /v1/{customBiddingAlgorithm=customers/*/customBiddingAlgorithms/*}:addAdvertiser` Add a DV360 advertiser to the custom bidding algorithm's advertisers. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.customBiddingAlgorithms/create` | `POST /v1/{parent=customers/*}/customBiddingAlgorithms` Creates an Ads Data Hub-managed custom bidding algorithm. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.customBiddingAlgorithms/delete` | `DELETE /v1/{name=customers/*/customBiddingAlgorithms/*}` Delete this custom bidding algorithm. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.customBiddingAlgorithms/execute` | `POST /v1/{name=customers/*/customBiddingAlgorithms/*}:execute` Scores the last 30 days of impressions for the custom bidding models. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.customBiddingAlgorithms/get` | `GET /v1/{name=customers/*/customBiddingAlgorithms/*}` Retrieves the requested Ads Data Hub-managed custom bidding algorithm. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.customBiddingAlgorithms/list` | `GET /v1/{parent=customers/*}/customBiddingAlgorithms` Lists the custom bidding algorithms managed by the specified Ads Data Hub customer. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.customBiddingAlgorithms/patch` | `PATCH /v1/{customBiddingAlgorithm.name=customers/*/customBiddingAlgorithms/*}` Updates the requested Ads Data Hub-managed custom bidding algorithm. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.customBiddingAlgorithms/removeAdvertiser` | `POST /v1/{customBiddingAlgorithm=customers/*/customBiddingAlgorithms/*}:removeAdvertiser` Remove a DV360 advertiser from the custom bidding algorithm's advertisers. |

## REST Resource: [v1.customers.inboundCustomerLinks](https://developers.google.com/ads-data-hub/reference/rest/v1/customers.inboundCustomerLinks)

| Methods ||
|---|---|
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.inboundCustomerLinks/list` | `GET /v1/{parent=customers/*}/inboundCustomerLinks` Lists links where another Ads Data Hub customer has granted access to the specified customer. |

## REST Resource: [v1.customers.outboundCustomerLinks](https://developers.google.com/ads-data-hub/reference/rest/v1/customers.outboundCustomerLinks)

| Methods ||
|---|---|
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.outboundCustomerLinks/list` | `GET /v1/{parent=customers/*}/outboundCustomerLinks` Lists links where the specified customer has granted access to other Ads Data Hub customers. |

## REST Resource: [v1.customers.tables](https://developers.google.com/ads-data-hub/reference/rest/v1/customers.tables)

| Methods ||
|---|---|
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.tables/get` | `GET /v1/{name=customers/*/tables/*}` Retrieves the requested Ads Data Hub table. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.tables/list` | `GET /v1/{parent=customers/*}/tables` Lists the Ads Data Hub tables to which the specified customer has access. |

## REST Resource: [v1.customers.tempTables](https://developers.google.com/ads-data-hub/reference/rest/v1/customers.tempTables)

| Methods ||
|---|---|
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.tempTables/get` | `GET /v1/{name=customers/*/tempTables/*}` Retrieves the requested Ads Data Hub temp table. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.tempTables/list` | `GET /v1/{parent=customers/*}/tempTables` Lists the Ads Data Hub temp tables that the customer has created. |

## REST Resource: [v1.customers.userListQueries](https://developers.google.com/ads-data-hub/reference/rest/v1/customers.userListQueries)

| Methods ||
|---|---|
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.userListQueries/create` | `POST /v1/{parent=customers/*}/userListQueries` Creates a user list query for later execution. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.userListQueries/delete` | `DELETE /v1/{name=customers/*/userListQueries/*}` Deletes a user list query. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.userListQueries/get` | `GET /v1/{name=customers/*/userListQueries/*}` Retrieves the requested user list query. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.userListQueries/list` | `GET /v1/{parent=customers/*}/userListQueries` Lists the user list queries owned by the specified customer. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.userListQueries/patch` | `PATCH /v1/{query.name=customers/*/userListQueries/*}` Updates an existing user list query. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.userListQueries/start` | `POST /v1/{name=customers/*/userListQueries/*}:start` Starts execution on a stored user list query. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.userListQueries/startTransient (deprecated)` | `POST /v1/{parent=customers/*}/userListQueries:startTransient` Starts execution on a transient user list query. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.userListQueries/validate` | `POST /v1/{parent=customers/*}/userListQueries:validate` Performs static validation checks on the provided user list query. |

## REST Resource: [v1.customers.userLists](https://developers.google.com/ads-data-hub/reference/rest/v1/customers.userLists)

| Methods ||
|---|---|
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.userLists/addEventMatchers (deprecated)` | `POST /v1/{userList=customers/*/userLists/*}:addEventMatchers` Adds event matchers to a frequency-based user list. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.userLists/addRecipients` | `POST /v1/{userList=customers/*/userLists/*}:addRecipients` Add entities to an Ads Data Hub-managed user list's recipients. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.userLists/create` | `POST /v1/{parent=customers/*}/userLists` Creates an Ads Data Hub-managed user list. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.userLists/delete` | `DELETE /v1/{name=customers/*/userLists/*}` Delete the requested Ads Data Hub-managed user list. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.userLists/generateFrequencyListMemberships (deprecated)` | `POST /v1/{name=customers/*/userLists/*}:generateFrequencyListMemberships` Generate memberships for the UserList. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.userLists/get` | `GET /v1/{name=customers/*/userLists/*}` Retrieves the requested Ads Data Hub-managed user list. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.userLists/list` | `GET /v1/{parent=customers/*}/userLists` Lists the user lists managed by the specified Ads Data Hub customer. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.userLists/patch` | `PATCH /v1/{userList.name=customers/*/userLists/*}` Updates the requested Ads Data Hub-managed user list. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.userLists/removeRecipients` | `POST /v1/{userList=customers/*/userLists/*}:removeRecipients` Removes entities from an Ads Data Hub-managed user list's recipients. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/customers.userLists/updateCrmBasedUserListMemberships` | `POST /v1/{name=customers/*/userLists/*}:updateCrmBasedUserListMemberships` Update memberships for the UserList. |

## REST Resource: [v1.operations](https://developers.google.com/ads-data-hub/reference/rest/v1/operations)

| Methods ||
|---|---|
| `https://developers.google.com/ads-data-hub/reference/rest/v1/operations/cancel` | `POST /v1/{name=operations/**}:cancel` Starts asynchronous cancellation on a long-running operation. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/operations/delete` | `DELETE /v1/{name=operations/**}` Deletes a long-running operation. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/operations/get` | `GET /v1/{name=operations/**}` Gets the latest state of a long-running operation. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/operations/list` | `GET /v1/{name}` Lists operations that match the specified filter in the request. |
| `https://developers.google.com/ads-data-hub/reference/rest/v1/operations/wait` | `POST /v1/{name=operations/**}:wait` Waits until the specified long-running operation is done or reaches at most a specified timeout, returning the latest state. |

## REST Resource: [v1.outages](https://developers.google.com/ads-data-hub/reference/rest/v1/outages)

| Methods ||
|---|---|
| `https://developers.google.com/ads-data-hub/reference/rest/v1/outages/list` | `GET /v1/outages` Lists the outages in descending order of outage start timestamp, and the look back window is 130 days. |